Index: stable/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config
===================================================================
--- stable/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 10447)
+++ stable/HeuristicLab.Clients.Hive.Slave.ConsoleClient/3.3/app.config	(revision 10451)
@@ -4,9 +4,10 @@
     <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
       <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
     </sectionGroup>
   </configSections>
   <runtime>
     <gcServer enabled="true" />
-  </runtime>
+  </runtime>      
   
   <system.serviceModel>
@@ -62,10 +63,7 @@
    
  </system.serviceModel>
-  
+
   <userSettings>
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-      <setting name="HeartbeatInterval" serializeAs="String">
-        <value>00:00:20</value>
-      </setting>
       <setting name="LastUsedFileName" serializeAs="String">
         <value>lastUsed.dat</value>
@@ -135,10 +133,45 @@
       </setting>
       <setting name="NrOfCoresToScavenge" serializeAs="String">
-        <value>2</value>
+        <value>-1</value>
       </setting>
       <setting name="ShutdownCommand" serializeAs="String">
         <value>shutdown.exe</value>
       </setting>
-   </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+      <setting name="HeartbeatInterval" serializeAs="String">
+        <value>00:00:40</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+    <HeuristicLab.Clients.Hive.Settings>
+      <setting name="MaxParallelUploads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="HLBinaryName" serializeAs="String">
+        <value>HeuristicLab 3.3.exe</value>
+      </setting>
+      <setting name="ResultPollingInterval" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="MaxParallelDownloads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="MaxRepeatServiceCalls" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="AnonymousUserName" serializeAs="String">
+        <value>anonymous</value>
+      </setting>
+      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
+        <value>
+          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+            xmlns:xsd="http://www.w3.org/2001/XMLSchema">
+            <string>netTcpBinding_IHiveService</string>
+            <string>wsHttpBinding_IHiveService</string>
+          </ArrayOfString>
+        </value>
+      </setting>
+      <setting name="MaxEndpointRetries" serializeAs="String">
+        <value>3</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.Settings>
   </userSettings>
 <startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.0"/></startup></configuration>
Index: stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj
===================================================================
--- stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj	(revision 10447)
+++ stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/HeuristicLab.Clients.Hive.Slave.WindowsService-3.3.csproj	(revision 10451)
@@ -154,5 +154,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
   </ItemGroup>
   <ItemGroup>
@@ -164,5 +166,5 @@
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <PropertyGroup>
-   <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+    <PreBuildEvent Condition=" '$(OS)' == 'Windows_NT' ">set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
 set ProjectDir=$(ProjectDir)
 set SolutionDir=$(SolutionDir)
@@ -170,5 +172,5 @@
 
 call PreBuildEvent.cmd</PreBuildEvent>
-<PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
+    <PreBuildEvent Condition=" '$(OS)' != 'Windows_NT' ">
 export ProjectDir=$(ProjectDir)
 export SolutionDir=$(SolutionDir)
Index: stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config
===================================================================
--- stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 10447)
+++ stable/HeuristicLab.Clients.Hive.Slave.WindowsService/3.3/app.config	(revision 10451)
@@ -4,4 +4,5 @@
     <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
       <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
     </sectionGroup>
   </configSections>
@@ -11,4 +12,11 @@
 
   <system.serviceModel>
+    <behaviors>
+      <endpointBehaviors>
+        <behavior name="HiveBehaviorConfiguration">
+          <dataContractSerializer maxItemsInObjectGraph="2147483647"/>
+        </behavior>
+      </endpointBehaviors>
+    </behaviors>
     <bindings>
       <wsHttpBinding>
@@ -42,5 +50,5 @@
     <client>
       <endpoint name="SlaveCommunicationServiceEndpoint" address="net.pipe://localhost/HeuristicLabSlaveCom" binding="netNamedPipeBinding" contract="HeuristicLab.Clients.Hive.SlaveCore.ServiceContracts.ISlaveCommunication"/>
-      <endpoint address="http://services.heuristiclab.com/Hive-3.3/HiveService.svc" binding="wsHttpBinding" bindingConfiguration="wsHttpBinding_Hive" contract="HeuristicLab.Clients.Hive.IHiveService" name="wsHttpBinding_IHiveService">
+      <endpoint address="http://services.heuristiclab.com/Hive-3.3/HiveService.svc" binding="wsHttpBinding" bindingConfiguration="wsHttpBinding_Hive" contract="HeuristicLab.Clients.Hive.IHiveService" name="wsHttpBinding_IHiveService" behaviorConfiguration="HiveBehaviorConfiguration">
         <identity>
           <certificate encodedValue="AwAAAAEAAAAUAAAAwK1+2oAmcy/mI2P2QjyiJRh0y60gAAAAAQAAACoCAAAwggImMIIBj6ADAgECAhAIkseQ2EEhgU720qJA61gqMA0GCSqGSIb3DQEBBAUAMCQxIjAgBgNVBAMTGXNlcnZpY2VzLmhldXJpc3RpY2xhYi5jb20wHhcNMTAwNTExMTExNDAyWhcNMzkxMjMxMjM1OTU5WjAkMSIwIAYDVQQDExlzZXJ2aWNlcy5oZXVyaXN0aWNsYWIuY29tMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCq26Bwmwc7k+4W30qLQ2j+FInEL5BuH6opDY6CSlrtt3xQS/anrhvpbf3QghLDVINzcHkzbPmm/SguG4F85QLB6xO+tJaOvRo0iEK5g3c307vMIru7FJwk/OhplEQ5J1hbDgL3zOJlrWlgtqRVxCtVdF3XroI9BctOt1NkeKv9ewIDAQABo1kwVzBVBgNVHQEETjBMgBCjbgdYd4j5JgUuJ1Wo/GxroSYwJDEiMCAGA1UEAxMZc2VydmljZXMuaGV1cmlzdGljbGFiLmNvbYIQCJLHkNhBIYFO9tKiQOtYKjANBgkqhkiG9w0BAQQFAAOBgQAb/2xk2uQad68shSPl/uixWgvFI8WkxOTBopOLaLtDxwCeZ3mWVHdV9VnixHtThubnEBXAhYOCQSIXWtQuXFWO+gH3YyjTRJY5kTmXyuvBRTn3/so5SrQ7Rdlm9hf6E5YVX3tCjAy7ybUyaDUkQfmH5vmvgvpMzRfsJ1qhnUpJiQ==" />
@@ -58,7 +66,4 @@
   <userSettings>
     <HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
-      <setting name="HeartbeatInterval" serializeAs="String">
-        <value>00:00:60</value>
-      </setting>
       <setting name="LastUsedFileName" serializeAs="String">
         <value>lastUsed.dat</value>
@@ -133,5 +138,40 @@
         <value>shutdown.exe</value>
       </setting>
+      <setting name="HeartbeatInterval" serializeAs="String">
+        <value>00:00:40</value>
+      </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+    <HeuristicLab.Clients.Hive.Settings>
+      <setting name="MaxParallelUploads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="HLBinaryName" serializeAs="String">
+        <value>HeuristicLab 3.3.exe</value>
+      </setting>
+      <setting name="ResultPollingInterval" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="MaxParallelDownloads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="MaxRepeatServiceCalls" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="AnonymousUserName" serializeAs="String">
+        <value>anonymous</value>
+      </setting>
+      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
+        <value>
+          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+            xmlns:xsd="http://www.w3.org/2001/XMLSchema">
+            <string>netTcpBinding_IHiveService</string>
+            <string>wsHttpBinding_IHiveService</string>
+          </ArrayOfString>
+        </value>
+      </setting>
+      <setting name="MaxEndpointRetries" serializeAs="String">
+        <value>3</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.Settings>
   </userSettings>
   
Index: stable/HeuristicLab.Clients.Hive.Slave/3.3/app.config
===================================================================
--- stable/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 10447)
+++ stable/HeuristicLab.Clients.Hive.Slave/3.3/app.config	(revision 10451)
@@ -4,4 +4,5 @@
     <sectionGroup name="userSettings" type="System.Configuration.UserSettingsGroup, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" >
       <section name="HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" allowExeDefinition="MachineToLocalUser" requirePermission="false" />
+      <section name="HeuristicLab.Clients.Hive.Settings" type="System.Configuration.ClientSettingsSection, System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" requirePermission="false" />
     </sectionGroup>
   </configSections>
@@ -141,4 +142,36 @@
       </setting>
     </HeuristicLab.Clients.Hive.SlaveCore.Properties.Settings>
+    <HeuristicLab.Clients.Hive.Settings>
+      <setting name="MaxParallelUploads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="HLBinaryName" serializeAs="String">
+        <value>HeuristicLab 3.3.exe</value>
+      </setting>
+      <setting name="ResultPollingInterval" serializeAs="String">
+        <value>00:00:20</value>
+      </setting>
+      <setting name="MaxParallelDownloads" serializeAs="String">
+        <value>2</value>
+      </setting>
+      <setting name="MaxRepeatServiceCalls" serializeAs="String">
+        <value>5</value>
+      </setting>
+      <setting name="AnonymousUserName" serializeAs="String">
+        <value>anonymous</value>
+      </setting>
+      <setting name="EndpointConfigurationPriorities" serializeAs="Xml">
+        <value>
+          <ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
+            xmlns:xsd="http://www.w3.org/2001/XMLSchema">
+            <string>netTcpBinding_IHiveService</string>
+            <string>wsHttpBinding_IHiveService</string>
+          </ArrayOfString>
+        </value>
+      </setting>
+      <setting name="MaxEndpointRetries" serializeAs="String">
+        <value>3</value>
+      </setting>
+    </HeuristicLab.Clients.Hive.Settings>
   </userSettings>
 </configuration>